function [e,E_x] = TL_plott(varargin)
%TL optical constants
%it appears this is the same calc as in the j a wollum software but the
%broadening term hasn't been fitted properly to most of the. Also likely
%needs a refit for the enif... 

film = '8';

if nargin == 6
    e1inf = varargin{1};
    A = varargin{2};
    C = varargin{3};
    E0 = varargin{4};
    Eg = varargin{5};
    eV = varargin{6};
elseif nargin == 0
    if strcmpi (film,'sinx')
    %   Jellison 1996
        A = 59.2;               %(eV)
        e1inf = 3.1;            %(eV)
        C = .49;                %(eV)
        E0 = 6.78;              %(eV)
        Eg = 4.5;               %(eV)
    elseif strcmpi (film,'L4')
        %L4 jellison 1998
        A = 202;               %(eV)
        e1inf = 1;            %(eV)
        C = 4.02;                %(eV)
        E0 = 3.5;              %(eV)
        Eg = 1.84;               %(eV)

    elseif strcmpi (film,'3')
        %3 jellison 1998
        A = 80;               %(eV)
        e1inf = 1;            %(eV)
        C = 7;                %(eV)
        E0 = 8.8;              %(eV)
        Eg = 2.74;               %(eV)

    elseif strcmpi (film,'21')
        %SiON wafer 22
        A = 222;               %(eV)
        e1inf = 0;            %(eV)
        C = 0;                %(eV)
        E0 = 14.9;              %(eV)
        Eg = 5.417;               %(eV)

    elseif strcmpi (film,'8')
        %SiON wafer 8
        A = 273;               %(eV)
        e1inf = 0;            %(eV)
        C = 10.26;                %(eV)
        E0 = 13.73;              %(eV)
        Eg = 8.11;               %(eV)

    % 273.0124041705781	10.263656589509688	13.731139167531031	8.116739127049513
    end
else
    error('Enter vars E1inf, A, C, E0, EG')
end


%E range from lambda inital to end
% lamb_s = 200;               %(nm)
% lamb_e = 1400;              %(nm)
% 
% nm_2_ev = 1239.84187;        %constant, related to fundamental constants
% 
% E_s = nm_2_ev/lamb_s;       %(ev)
% E_e = nm_2_ev/lamb_e;       %(ev)
% 
% E_x = E_e:(E_s-E_e)/99:E_s;
% E_x = E_x';

E_x = eV;

%TL imaginery dielectric constant from EQUN (4) [Jelliosn 1996]
for i  =  1:length(E_x)
    if E_x(i) > Eg
        e2(i) = A*C*E0*(E_x(i)-Eg)^2/(((E_x(i)^2-E0^2)^2+C^2*E_x(i)^2)*E_x(i));
    else
        e2(i) = 0;
    end
end

e1 = e2_2_e1 (A, e1inf, C, E0, Eg, E_x);
e1(isnan(e1)) = 0;
e2(isnan(e2)) = 0;
e = e1 + 1i*e2;
end

function e1 = e2_2_e1 (A, E1inf, C, E0, Eg, E_x)
    
    % Frome [Jellison 1996] equations 7a to 7e
    for i  =  1:length(E_x)
        
    gamma = (E0^2-C^2/2)^0.5;                                       %eV^1
    alpha = (4*E0^2-C^2)^0.5;                                       %eV^1
    skigg4 = (E_x(i)^2-gamma^2)^2+alpha^2*C^2/4;                    %eV^4
    a_atan = (E_x(i)^2-E0^2)*(E0^2+Eg^2)+Eg^2*C^2;                  %eV^4
    a_ln = (Eg^2-E0^2)*E_x(i)^2 + Eg^2*C^2 - E0^2*(E0^2+3*Eg^2);    %eV^4
    
  
   
    e1(i) = E1inf + ...
        A*C/pi/skigg4*a_ln/alpha/E0/2*log((E0^2+Eg^2+alpha*Eg)/(E0^2+Eg^2-alpha*Eg))... 
        -A/pi/skigg4*a_atan/E0*(pi - atan((2*Eg+alpha)/C) + atan((-2*Eg+alpha)/C))...
        +2*A*E0/pi/skigg4/alpha*Eg*(E_x(i)^2-gamma^2)*(pi + 2*atan(2*(gamma^2-Eg^2)/alpha/C))...
        -A*E0*C/pi/skigg4*(E_x(i)^2+Eg^2)/E_x(i)*log((abs(E_x(i)-Eg))/(E_x(i)+Eg))...
        +2*A*E0*C*Eg/pi/skigg4*log((abs(E_x(i)-Eg)*(E_x(i)+Eg))/((E0^2-Eg^2)^2+Eg^2*C^2)^0.5);
    end
    
end
